diff --git a/reviewboard/hostingsvcs/tests/test_rbgateway.py b/reviewboard/hostingsvcs/tests/test_rbgateway.py
index c0a0be948820445c5ba50c960e5c47b657dca454..c5f39117b307cbd0eb5231f853ba95ef037bc82c 100644
--- a/reviewboard/hostingsvcs/tests/test_rbgateway.py
+++ b/reviewboard/hostingsvcs/tests/test_rbgateway.py
@@ -1,7 +1,10 @@
 """Unit tests for the ReviewBoardGateway hosting service."""
 
+from __future__ import annotations
+
 import hashlib
 import hmac
+from typing import TYPE_CHECKING
 
 from django.contrib.auth.models import User
 from django.test.client import RequestFactory
@@ -9,6 +12,7 @@
 from djblets.testing.decorators import add_fixtures
 
 from reviewboard.hostingsvcs.hook_utils import logger
+from reviewboard.hostingsvcs.rbgateway import ReviewBoardGateway
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
 from reviewboard.reviews.models import ReviewRequest
 from reviewboard.scmtools.core import Branch, Commit
@@ -18,8 +22,14 @@
 from reviewboard.site.models import LocalSite
 from reviewboard.site.urlresolvers import local_site_reverse
 
-
-class ReviewBoardGatewayTestCase(HostingServiceTestCase):
+if TYPE_CHECKING:
+    from django.test.client import _MonkeyPatchedWSGIResponse
+
+    from reviewboard.hostingsvcs.base.hosting_service import \
+        HostingServiceCredentials
+
+
+class ReviewBoardGatewayTestCase(HostingServiceTestCase[ReviewBoardGateway]):
     """Base test case for the ReviewBoardGateway hosting service."""
 
     service_name = 'rbgateway'
@@ -29,21 +39,24 @@
         'private_token': encrypt_password('abc123'),
     }
 
-    default_http_credentials = {
-        'headers': {
-            'PRIVATE-TOKEN': 'abc123',
-        },
-    }
-
     default_repository_extra_data = {
         'rbgateway_repo_name': 'myrepo',
     }
 
+    @property
+    def default_http_credentials(self) -> HostingServiceCredentials:
+        """The default credentials sent in HTTP requests."""
+        return {
+            'headers': {
+                'PRIVATE-TOKEN': 'abc123',
+            },
+        }
+
 
 class ReviewBoardGatewayClientTests(ReviewBoardGatewayTestCase):
     """Unit tests for ReviewBoardGatewayClient."""
 
-    def test_request_includes_private_token(self):
+    def test_request_includes_private_token(self) -> None:
         """Testing ReviewBoardGatewayClient API requests include PRIVATE-TOKEN
         header
         """
@@ -59,14 +72,14 @@
 class ReviewBoardGatewayTests(ReviewBoardGatewayTestCase):
     """Unit tests for the ReviewBoardGateway hosting service."""
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing ReviewBoardGateway service support capabilities"""
         self.assertTrue(self.service_class.supports_repositories)
         self.assertTrue(self.service_class.supports_post_commit)
         self.assertFalse(self.service_class.supports_bug_trackers)
         self.assertFalse(self.service_class.supports_ssh_key_association)
 
-    def test_repo_field_values(self):
+    def test_repo_field_values(self) -> None:
         """Testing ReviewBoardGateway.get_repository_fields for Git"""
         self.assertEqual(
             self.get_repository_fields(
@@ -80,7 +93,7 @@
                 'path': 'https://example.com/repos/myrepo/path',
             })
 
-    def test_get_repository_hook_instructions(self):
+    def test_get_repository_hook_instructions(self) -> None:
         """Testing ReviewBoardGateway.get_repository_hook_instructions"""
         account = self.create_hosting_account()
         repository = self.create_repository(hosting_account=account)
@@ -103,7 +116,7 @@
             content)
         self.assertIn('Review Board supports closing', content)
 
-    def test_authorize(self):
+    def test_authorize(self) -> None:
         """Testing ReviewBoardGateway.authorize"""
         hosting_account = self.create_hosting_account(data={})
         self.assertFalse(hosting_account.is_authorized)
@@ -133,7 +146,7 @@
                 'Content-Length': '0',
             })
 
-    def test_check_repository(self):
+    def test_check_repository(self) -> None:
         """Testing ReviewBoardGateway.check_repository"""
         paths = {
             '/repos/myrepo/path': {
@@ -150,7 +163,7 @@
             url='https://example.com/repos/myrepo/path',
             headers=None)
 
-    def test_check_repository_with_invalid_repo(self):
+    def test_check_repository_with_invalid_repo(self) -> None:
         """Testing ReviewBoardGateway.check_repository with invalid
         repository
         """
@@ -164,7 +177,7 @@
             url='https://example.com/repos/invalid/path',
             headers=None)
 
-    def test_get_branches_git(self):
+    def test_get_branches_git(self) -> None:
         """Testing ReviewBoardGateway.get_branches for a Git repository"""
         payload = self.dump_json([
             {
@@ -197,7 +210,7 @@
                        commit='83904e6acb60e7ec0dcaae6c09a579ab44d0cf38'),
             ])
 
-    def test_get_branches_hg(self):
+    def test_get_branches_hg(self) -> None:
         """Testing ReviewBoardGateway.get_branches for an Hg repository"""
         payload = self.dump_json([
             {
@@ -230,7 +243,7 @@
                        commit='0731875ed7a14bdd53503b27b30a08a0452068cf'),
             ])
 
-    def test_get_commits(self):
+    def test_get_commits(self) -> None:
         """Testing ReviewBoardGateway.get_commits"""
         payload = self.dump_json([
             {
@@ -292,7 +305,7 @@
         for commit in commits:
             self.assertIsNone(commit.diff)
 
-    def test_get_change(self):
+    def test_get_change(self) -> None:
         """Testing ReviewBoardGateway.get_change"""
         diff = (
             'diff --git a/test b/test\n'
@@ -343,20 +356,20 @@
 
     fixtures = ['test_users', 'test_scmtools']
 
-    def test_close_submitted_hook_git(self):
+    def test_close_submitted_hook_git(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with a Git
         repository
         """
         self._test_post_commit_hook(tool_name='Git')
 
-    def test_close_submiteed_hook_git_unpublished(self):
+    def test_close_submiteed_hook_git_unpublished(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         unpublished review request in a Git repository
         """
         self._test_post_commit_hook(tool_name='Git', publish=False)
 
     @add_fixtures(['test_site'])
-    def test_close_submiteed_hook_git_local_site_unpublished(self):
+    def test_close_submiteed_hook_git_local_site_unpublished(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         unpublished review request in a Git repository on a Local Site
         """
@@ -365,7 +378,7 @@
             local_site=LocalSite.objects.get(name=self.local_site_name),
             publish=False)
 
-    def test_close_submitted_hook_git_tag_target(self):
+    def test_close_submitted_hook_git_tag_target(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         Git repository and a tag target
         """
@@ -374,7 +387,7 @@
             expected_close_msg='Pushed to release-1.0.7 (bbbbbbb)',
             target_tags=['release-1.0.7', 'some-tag'])
 
-    def test_close_submitted_hook_git_no_target(self):
+    def test_close_submitted_hook_git_no_target(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         Git repository and no target information
         """
@@ -383,14 +396,14 @@
             expected_close_msg='Pushed to bbbbbbb',
             target_branch=None)
 
-    def test_close_submitted_hook_hg(self):
+    def test_close_submitted_hook_hg(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         Mercurial repository
         """
         self._test_post_commit_hook(tool_name='Mercurial')
 
     @add_fixtures(['test_site'])
-    def test_close_submitted_hook_hg_local_site(self):
+    def test_close_submitted_hook_hg_local_site(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         Mercurial repository on a Local Site
         """
@@ -398,14 +411,14 @@
             tool_name='Mercurial',
             local_site=LocalSite.objects.get(name=self.local_site_name))
 
-    def test_close_submitted_hook_hg_unpublished(self):
+    def test_close_submitted_hook_hg_unpublished(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         unpublished review request in a Mercurial repository
         """
         self._test_post_commit_hook(tool_name='Mercurial', publish=False)
 
     @add_fixtures(['test_site'])
-    def test_close_submitted_hook_hg_local_site_unpublished(self):
+    def test_close_submitted_hook_hg_local_site_unpublished(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         unpublished review request in a Mercurial repository on a Local Site
         """
@@ -414,7 +427,7 @@
             local_site=LocalSite.objects.get(name=self.local_site_name),
             publish=False)
 
-    def test_close_submitted_hook_hg_bookmark_target(self):
+    def test_close_submitted_hook_hg_bookmark_target(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         Mercurial repository and a bookmark target
         """
@@ -423,7 +436,7 @@
             expected_close_msg='Pushed to dev-work (bbbbbbb)',
             target_bookmarks=['dev-work'])
 
-    def test_close_submitted_hook_hg_tag_target(self):
+    def test_close_submitted_hook_hg_tag_target(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         Mercurial repository and a tag target
         """
@@ -433,7 +446,7 @@
             target_branch='default',
             target_tags=['@', 'tip'])
 
-    def test_close_submitted_hook_hg_no_target(self):
+    def test_close_submitted_hook_hg_no_target(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an
         Mercurial repository and no target information
         """
@@ -442,7 +455,7 @@
             expected_close_msg='Pushed to bbbbbbb',
             target_branch=None)
 
-    def test_close_submitted_hook_invalid_signature(self):
+    def test_close_submitted_hook_invalid_signature(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with an invalid
         signature
         """
@@ -477,7 +490,7 @@
         self.assertEqual(rsp.status_code, 400)
         self.assertEqual(rsp.content, b'Bad signature.')
 
-    def test_close_submitted_hook_malformed_payload(self):
+    def test_close_submitted_hook_malformed_payload(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook with a malformed
         signature
         """
@@ -509,7 +522,7 @@
         self.assertEqual(rsp.status_code, 400)
         self.assertEqual(rsp.content, b'Invalid payload format.')
 
-    def test_close_submitted_hook_incomplete_payload(self):
+    def test_close_submitted_hook_incomplete_payload(self) -> None:
         account = self.create_hosting_account()
         repository = self.create_repository(tool_name='Git',
                                             hosting_account=account)
@@ -540,7 +553,7 @@
         self.assertEqual(rsp.status_code, 400)
         self.assertEqual(rsp.content, b'Invalid payload; expected "commits".')
 
-    def test_close_submitted_hook_invalid_event(self):
+    def test_close_submitted_hook_invalid_event(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook endpoint with an
         invalid event
         """
@@ -576,7 +589,7 @@
         self.assertEqual(rsp.content,
                          b'Only "ping" and "push" events are supported.')
 
-    def test_close_submitted_hook_with_invalid_review_request(self):
+    def test_close_submitted_hook_with_invalid_review_request(self) -> None:
         """Testing the ReviewBoardGateway close-submitted hook endpoint with an
         invalid review request
         """
@@ -613,7 +626,7 @@
             'close_all_review_requests: Review request #%s does not exist.',
             9999))
 
-    def test_ping_event(self):
+    def test_ping_event(self) -> None:
         """Testing the ReviewBoardGateway close submitted hook endpoint with
         event=ping
         """
@@ -648,23 +661,34 @@
         self.assertEqual(rsp.status_code, 200)
         self.assertEqual(rsp.content, b'')
 
-    def _test_post_commit_hook(self, tool_name, local_site=None, publish=True,
-                               expected_close_msg='Pushed to master (bbbbbbb)',
-                               **kwargs):
+    def _test_post_commit_hook(
+        self,
+        tool_name: str,
+        local_site: (LocalSite | None) = None,
+        publish: bool = True,
+        expected_close_msg: str = 'Pushed to master (bbbbbbb)',
+        **kwargs,
+    ) -> None:
         """Testing posting to a commit hook.
 
         This will simulate pushing a commit and posting the resulting webhook
         payload from RB Gateway to the handler for the hook.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCM tool to use.
 
             local_site (reviewboard.site.models.LocalSite, optional):
                 The Local Site owning the review request.
 
-            publish (bool):
+            publish (bool, optional):
                 Whether or not to use a published review request.
+
+            expected_close_msg (str, optional):
+                The expected message for the close operation.
+
+            **kwargs (dict):
+                Additional keyword arguments to pass to the commit hook.
         """
         account = self.create_hosting_account(local_site=local_site)
         repository = self.create_repository(tool_name=tool_name,
@@ -691,6 +715,7 @@
             repository_name=repository.name,
             secret=repository.get_or_create_hooks_uuid(),
             **kwargs)
+        assert response is not None
         self.assertEqual(response.status_code, 200)
 
         review_request = ReviewRequest.objects.get(pk=review_request.pk)
@@ -701,36 +726,43 @@
         changedesc = review_request.changedescs.get()
         self.assertEqual(changedesc.text, expected_close_msg)
 
-    def _post_commit_hook_payload(self, post_url, repository_name,
-                                  review_request_url, secret,
-                                  event='push', target_branch='master',
-                                  target_bookmarks=None, target_tags=None):
+    def _post_commit_hook_payload(
+        self,
+        post_url: str,
+        repository_name: str,
+        review_request_url: str,
+        secret: str,
+        event: str = 'push',
+        target_branch: (str | None) = 'master',
+        target_bookmarks: (str | None) = None,
+        target_tags: (str | None) = None,
+    ) -> _MonkeyPatchedWSGIResponse:
         """Post a payload for a hook for testing.
 
         Args:
-            post_url (unicode):
+            post_url (str):
                 The URL to post to.
 
-            repository_name (unicode):
+            repository_name (str):
                 The name of the repository.
 
-            review_request_url (unicode):
+            review_request_url (str):
                 The URL of the review request being represented in the
                 payload.
 
-            secret (unicode):
+            secret (str):
                 The HMAC secret for the message.
 
-            event (unicode, optional):
+            event (str, optional):
                 The webhook event.
 
-            target_branch (unicode, optional):
+            target_branch (str, optional):
                 The target branch to include in the payload.
 
-            target_bookmarks (unicode, optional):
+            target_bookmarks (str, optional):
                 The target Mercurial bookmarks to include in the payload.
 
-            target_tags (unicode, optional):
+            target_tags (str, optional):
                 The target tags to include in the payload.
 
         Results:
diff --git a/reviewboard/hostingsvcs/tests/test_redmine.py b/reviewboard/hostingsvcs/tests/test_redmine.py
index e050d9a1402dd0d8c15e02d1b3352ba0382f85ac..41a20d89d37abc052e491914687b11f6c5bf6cdf 100644
--- a/reviewboard/hostingsvcs/tests/test_redmine.py
+++ b/reviewboard/hostingsvcs/tests/test_redmine.py
@@ -1,20 +1,23 @@
 """Unit tests for the Redmine hosting service."""
 
+from __future__ import annotations
+
+from reviewboard.hostingsvcs.redmine import Redmine
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
 
 
-class RedmineTests(HostingServiceTestCase):
+class RedmineTests(HostingServiceTestCase[Redmine]):
     """Unit tests for the Redmine hosting service."""
 
     service_name = 'redmine'
     fixtures = ['test_scmtools']
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing Redmine service support capabilities"""
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertFalse(self.service_class.supports_repositories)
 
-    def test_get_bug_tracker_field(self):
+    def test_get_bug_tracker_field(self) -> None:
         """Testing Redmine.get_bug_tracker_field"""
         self.assertFalse(
             self.service_class.get_bug_tracker_requires_username())
diff --git a/reviewboard/hostingsvcs/tests/test_sourceforge.py b/reviewboard/hostingsvcs/tests/test_sourceforge.py
index 6740be4e83a32b641b3647ae622c606f1ae5bd8f..08cbaccdb60348f7b64d4da9a8094eb0cb1c25ef 100644
--- a/reviewboard/hostingsvcs/tests/test_sourceforge.py
+++ b/reviewboard/hostingsvcs/tests/test_sourceforge.py
@@ -1,19 +1,22 @@
 """Unit tests for the SourceForge hosting service."""
 
+from __future__ import annotations
+
+from reviewboard.hostingsvcs.sourceforge import SourceForge
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
 
 
-class SourceForgeTests(HostingServiceTestCase):
+class SourceForgeTests(HostingServiceTestCase[SourceForge]):
     """Unit tests for the SourceForge hosting service."""
 
     service_name = 'sourceforge'
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing SourceForge service support capabilities"""
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertTrue(self.service_class.supports_repositories)
 
-    def test_get_repository_fields_with_bazaar(self):
+    def test_get_repository_fields_with_bazaar(self) -> None:
         """Testing SourceForge.get_repository_fields for Bazaar"""
         self.assertEqual(
             self.get_repository_fields(
@@ -28,7 +31,7 @@
                                 'myproj'),
             })
 
-    def test_get_repository_fields_with_cvs(self):
+    def test_get_repository_fields_with_cvs(self) -> None:
         """Testing SourceForge.get_repository_fields for CVS"""
         self.assertEqual(
             self.get_repository_fields(
@@ -43,7 +46,7 @@
                 'mirror_path': 'myproj.cvs.sourceforge.net/cvsroot/myproj',
             })
 
-    def test_get_repository_fields_with_mercurial(self):
+    def test_get_repository_fields_with_mercurial(self) -> None:
         """Testing SourceForge.get_repository_fields for Mercurial"""
         self.assertEqual(
             self.get_repository_fields(
@@ -57,7 +60,7 @@
                 'mirror_path': 'ssh://myproj.hg.sourceforge.net/hgroot/myproj',
             })
 
-    def test_get_repository_fields_with_svn(self):
+    def test_get_repository_fields_with_svn(self) -> None:
         """Testing SourceForge.get_repository_fields for Subversion"""
         self.assertEqual(
             self.get_repository_fields(
diff --git a/reviewboard/hostingsvcs/tests/test_trac.py b/reviewboard/hostingsvcs/tests/test_trac.py
index ec170d8096b52d1b59e822a5562bd17d30beb380..633bbdefabb289c3f53c7dee7643c3e4a5b3a761 100644
--- a/reviewboard/hostingsvcs/tests/test_trac.py
+++ b/reviewboard/hostingsvcs/tests/test_trac.py
@@ -1,20 +1,23 @@
 """Unit tests for the Trac hosting service."""
 
+from __future__ import annotations
+
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
+from reviewboard.hostingsvcs.trac import Trac
 
 
-class TracTests(HostingServiceTestCase):
+class TracTests(HostingServiceTestCase[Trac]):
     """Unit tests for the Trac hosting service."""
 
     service_name = 'trac'
     fixtures = ['test_scmtools']
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing Trac service support capabilities"""
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertFalse(self.service_class.supports_repositories)
 
-    def test_get_bug_tracker_field(self):
+    def test_get_bug_tracker_field(self) -> None:
         """Testing Trac.get_bug_tracker_field"""
         self.assertFalse(
             self.service_class.get_bug_tracker_requires_username())
diff --git a/reviewboard/hostingsvcs/tests/test_unfuddle.py b/reviewboard/hostingsvcs/tests/test_unfuddle.py
index 1498a5ff0ed3524dbe1c99504b400111290f6691..c1eda606c3ee88c22bf499b936084241ea5ac2c8 100644
--- a/reviewboard/hostingsvcs/tests/test_unfuddle.py
+++ b/reviewboard/hostingsvcs/tests/test_unfuddle.py
@@ -1,15 +1,18 @@
 """Unit tests for the Unfuddle hosting service."""
 
+from __future__ import annotations
+
 from urllib.error import HTTPError
 
 from reviewboard.hostingsvcs.errors import RepositoryError
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
+from reviewboard.hostingsvcs.unfuddle import Unfuddle
 from reviewboard.scmtools.crypto_utils import (decrypt_password,
                                                encrypt_password)
 from reviewboard.scmtools.errors import FileNotFoundError
 
 
-class UnfuddleTests(HostingServiceTestCase):
+class UnfuddleTests(HostingServiceTestCase[Unfuddle]):
     """Unit tests for the Unfuddle hosting service."""
 
     service_name = 'unfuddle'
@@ -26,12 +29,12 @@
         'unfuddle_repo_name': 'myrepo',
     }
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing Unfuddle service support capabilities"""
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertTrue(self.service_class.supports_repositories)
 
-    def test_get_repository_fields_with_git(self):
+    def test_get_repository_fields_with_git(self) -> None:
         """Testing Unfuddle.get_repository_fields for Git"""
         self.assertEqual(
             self.get_repository_fields(
@@ -48,7 +51,7 @@
                                 'mydomain_myrepo/'),
             })
 
-    def test_get_repository_fields_with_subversion(self):
+    def test_get_repository_fields_with_subversion(self) -> None:
         """Testing Unfuddle.get_repository_fields for Subversion"""
         self.assertEqual(
             self.get_repository_fields(
@@ -65,7 +68,7 @@
                                 'mydomain_myrepo'),
             })
 
-    def test_authorize(self):
+    def test_authorize(self) -> None:
         """Testing Unfuddle.authorize"""
         hosting_account = self.create_hosting_account(data={})
 
@@ -93,7 +96,7 @@
                          'abc123')
         self.assertTrue(ctx.service.is_authorized())
 
-    def test_check_repository(self):
+    def test_check_repository(self) -> None:
         """Testing Unfuddle.check_repository"""
         payload = self.dump_json([{
             'id': 2,
@@ -114,7 +117,7 @@
                 'Accept': 'application/json',
             })
 
-    def test_check_repository_with_wrong_repo_type(self):
+    def test_check_repository_with_wrong_repo_type(self) -> None:
         """Testing Unfuddle.check_repository with wrong repo type"""
         payload = self.dump_json([{
             'id': 2,
@@ -139,7 +142,7 @@
                 'Accept': 'application/json',
             })
 
-    def test_get_file_with_svn_and_base_commit_id(self):
+    def test_get_file_with_svn_and_base_commit_id(self) -> None:
         """Testing Unfuddle.get_file with Subversion and base commit ID"""
         self._test_get_file(
             tool_name='Subversion',
@@ -147,7 +150,7 @@
             base_commit_id='456',
             expected_revision='456')
 
-    def test_get_file_with_svn_and_revision(self):
+    def test_get_file_with_svn_and_revision(self) -> None:
         """Testing Unfuddle.get_file with Subversion and revision"""
         self._test_get_file(
             tool_name='Subversion',
@@ -155,7 +158,7 @@
             base_commit_id=None,
             expected_revision='123')
 
-    def test_get_file_with_git_and_base_commit_id(self):
+    def test_get_file_with_git_and_base_commit_id(self) -> None:
         """Testing Unfuddle.get_file with Git and revision with base commit ID
         """
         self._test_get_file(
@@ -164,7 +167,7 @@
             base_commit_id='456',
             expected_revision='456')
 
-    def test_get_file_with_git_and_revision(self):
+    def test_get_file_with_git_and_revision(self) -> None:
         """Testing Unfuddle.get_file with Git and revision without base commit
         ID
         """
@@ -175,7 +178,7 @@
             expected_revision=None,
             expected_error=True)
 
-    def test_get_file_exists_with_svn_and_base_commit_id(self):
+    def test_get_file_exists_with_svn_and_base_commit_id(self) -> None:
         """Testing Unfuddle.get_file_exists with Subversion and base commit ID
         """
         self._test_get_file_exists(
@@ -185,7 +188,7 @@
             expected_revision='456',
             expected_found=True)
 
-    def test_get_file_exists_with_svn_and_revision(self):
+    def test_get_file_exists_with_svn_and_revision(self) -> None:
         """Testing Unfuddle.get_file_exists with Subversion and revision"""
         self._test_get_file_exists(
             tool_name='Subversion',
@@ -194,7 +197,7 @@
             expected_revision='123',
             expected_found=True)
 
-    def test_get_file_exists_with_svn_and_revision_not_found(self):
+    def test_get_file_exists_with_svn_and_revision_not_found(self) -> None:
         """Testing Unfuddle.get_file_exists with Subversion and revision not
         found
         """
@@ -205,7 +208,7 @@
             expected_revision='123',
             expected_found=False)
 
-    def test_get_file_exists_with_git_and_base_commit_id(self):
+    def test_get_file_exists_with_git_and_base_commit_id(self) -> None:
         """Testing Unfuddle.get_file_exists with Git and revision with base
         commit ID
         """
@@ -216,7 +219,9 @@
             expected_revision='456',
             expected_found=True)
 
-    def test_get_file_exists_with_git_and_revision_no_base_commit_id(self):
+    def test_get_file_exists_with_git_and_revision_no_base_commit_id(
+        self,
+    ) -> None:
         """Testing Unfuddle.get_file_exists with Git and revision without
         base commit ID
         """
@@ -228,7 +233,7 @@
             expected_found=False,
             expected_error=True)
 
-    def test_get_file_exists_with_git_and_revision_not_found(self):
+    def test_get_file_exists_with_git_and_revision_not_found(self) -> None:
         """Testing Unfuddle.get_file_exists with Git and revision not found"""
         self._test_get_file_exists(
             tool_name='Git',
@@ -237,21 +242,27 @@
             expected_revision='456',
             expected_found=False)
 
-    def _test_get_file(self, tool_name, revision, base_commit_id,
-                       expected_revision, expected_error=False):
+    def _test_get_file(
+        self,
+        tool_name: str,
+        revision: str,
+        base_commit_id: str,
+        expected_revision: str,
+        expected_error: bool = False,
+    ) -> None:
         """Common function for testing file fetching.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The registered name of the SCMTool.
 
-            revision (unicode):
+            revision (str):
                 The revision to fetch.
 
-            base_commit_id (unicode):
+            base_commit_id (str):
                 The ID the commit is based on.
 
-            expected_revision (unicode):
+            expected_revision (str):
                 The expected revision to find in the URL.
 
             expected_error (bool, optional):
@@ -294,22 +305,28 @@
             self.assertIsInstance(result, bytes)
             self.assertEqual(result, b'My data')
 
-    def _test_get_file_exists(self, tool_name, revision, base_commit_id,
-                              expected_revision, expected_found=True,
-                              expected_error=False):
+    def _test_get_file_exists(
+        self,
+        tool_name: str,
+        revision: str,
+        base_commit_id: str,
+        expected_revision: str,
+        expected_found: bool = True,
+        expected_error: bool = False,
+    ) -> None:
         """Common function for testing file existence checks.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The registered name of the SCMTool.
 
-            revision (unicode):
+            revision (str):
                 The revision to fetch.
 
-            base_commit_id (unicode):
+            base_commit_id (str):
                 The ID the commit is based on.
 
-            expected_revision (unicode):
+            expected_revision (str):
                 The expected revision to find in the URL.
 
             expected_found (bool, optional):
diff --git a/reviewboard/hostingsvcs/tests/test_version_one.py b/reviewboard/hostingsvcs/tests/test_version_one.py
index 5b8fc11c1d22f9ba6fd87fed1d2130921b9c8d2f..f4ed05bcac969a543d7213f4d624ea7ee26fc0a6 100644
--- a/reviewboard/hostingsvcs/tests/test_version_one.py
+++ b/reviewboard/hostingsvcs/tests/test_version_one.py
@@ -1,20 +1,23 @@
 """Unit tests for the VersionOne hosting service."""
 
+from __future__ import annotations
+
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
+from reviewboard.hostingsvcs.versionone import VersionOne
 
 
-class VersionOneTests(HostingServiceTestCase):
+class VersionOneTests(HostingServiceTestCase[VersionOne]):
     """Unit tests for the VersionOne hosting service."""
 
     service_name = 'versionone'
     fixtures = ['test_scmtools']
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing VersionOne service support capabilities"""
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertFalse(self.service_class.supports_repositories)
 
-    def test_get_bug_tracker_field(self):
+    def test_get_bug_tracker_field(self) -> None:
         """Testing VersionOne.get_bug_tracker_field"""
         self.assertFalse(
             self.service_class.get_bug_tracker_requires_username())
